package cn.com.ctop.kuaishou.modules.batch.controller;

import cn.com.ctop.common.module.annotation.AutoLog;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.QueryGenerator;
import cn.com.ctop.common.module.utils.StringUtils;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouVideoGet;
import cn.com.ctop.kuaishou.modules.batch.entity.vo.KuaiShouVideoGetVo;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouReportDailyMaterialService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouVideoGetService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * @Description: 快手-获取视频接口
 * @Author: jeecg-boot
 * @Date: 2019-07-25
 * @Version: V1.0
 */
@Slf4j
@Api(tags = "快手-获取视频接口")
@RestController
@RequestMapping("/kuaishou/kuaiShouVideoGet")
public class KuaiShouVideoGetController {
    @Autowired
    private IKuaiShouVideoGetService kuaiShouVideoGetService;
    @Autowired
    private IKuaiShouReportDailyMaterialService kuaiShouReportDailyMaterialService;

    /**
     * 分页列表查询
     *
     * @param kuaiShouVideoGet
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-分页列表查询")
    @ApiOperation(value = "快手-获取视频接口-分页列表查询", notes = "快手-获取视频接口-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaiShouVideoGet>> queryPageList(KuaiShouVideoGet kuaiShouVideoGet,
                                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                         HttpServletRequest req) {
        Result<IPage<KuaiShouVideoGet>> result = new Result<IPage<KuaiShouVideoGet>>();
        QueryWrapper<KuaiShouVideoGet> queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouVideoGet, req.getParameterMap());
        Page<KuaiShouVideoGet> page = new Page<KuaiShouVideoGet>(pageNo, pageSize);
        IPage<KuaiShouVideoGet> pageList = kuaiShouVideoGetService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 真人、制作标签素材统计报表
     *
     * @return
     */
    @GetMapping(value = "/labelMaterialList")
    public Result<Object> labelMaterialList(String companyId, String realname, String roleCode, String startTime, String endTime, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize) {
        try {
            if (Check.isNull(startTime) || Check.isNull(endTime)) {
                return Result.error("请选择查询日期");
            }
            return kuaiShouReportDailyMaterialService.labelMaterialList(companyId, realname, roleCode, startTime, endTime, pageNo, pageSize);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return Result.error("查询失败");

    }


    @GetMapping(value = "/getVideoList")
    public Result<PageInfo<KuaiShouVideoGetVo>> getVideoList(Long accountId,
                                                             String startDate,
                                                             String endDate,
                                                             String materialType,
                                                             String channelType,
                                                             String signatures,
                                                             String orderBy,
                                                             @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                             @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                             HttpServletRequest req) {


        Result<PageInfo<KuaiShouVideoGetVo>> result = new Result<>();
        try {
            if (Check.isNull(accountId)) {
                throw new Exception("请传入账户id");
            }
            if (Check.isNull(materialType)) {
                throw new Exception("请传入素材类型");
            }
            if (Check.isNull(channelType)) {
                throw new Exception("请传入素材渠道");
            }
            if (Check.isNull(orderBy)) {
                throw new Exception("请传入排序方式");
            }

            List<KuaiShouVideoGetVo> list = new ArrayList<>();
            PageHelper.startPage(pageNo, pageSize);
            Map<String, Object> requestMap = new HashMap<>();
            requestMap.put("accountId", accountId);
            requestMap.put("orderBy", orderBy);
            requestMap.put("materialType", materialType);
            requestMap.put("channelType", channelType);
            if (!Check.isNull(signatures)) {
                String[] signatureArray = signatures.split(",");
                requestMap.put("signatureList", signatureArray);
            }
            if ("time".equals(orderBy)) {
                if (!Check.isNull(startDate) && !Check.isNull(endDate)) {
                    requestMap.put("startDate", startDate);
                    requestMap.put("endDate", endDate);
                }
                list = kuaiShouVideoGetService.getVideoList(requestMap);
            } else if ("cost".equals(orderBy)) {
                if (!Check.isNull(startDate) && !Check.isNull(endDate)) {
                    requestMap.put("startDate", startDate);
                    requestMap.put("endDate", endDate);
                }
                list = kuaiShouReportDailyMaterialService.getVideoList(requestMap);
            }
            PageInfo<KuaiShouVideoGetVo> pageInfo = new PageInfo<>(list);
            result.setSuccess(true);
            result.setResult(pageInfo);
        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
            result.setMessage(e.getMessage());
        }


        return result;

    }


    public static Map<String, Object> parseJSON2Map(String jsonStr) {
        Map<String, Object> map = new HashMap<String, Object>();
        JSONObject json = JSONObject.parseObject(jsonStr);
        for (Object k : json.keySet()) {
            Object v = json.get(k);
            if (v instanceof JSONArray) {
                List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
                Iterator<Object> it = ((JSONArray) v).iterator();
                while (it.hasNext()) {
                    JSONObject json2 = (JSONObject) it.next();
                    list.add(parseJSON2Map(json2.toString()));
                }
                map.put(k.toString(), list);
            } else {
                map.put(k.toString(), v);
            }
        }
        return map;
    }


    /**
     * 添加
     *
     * @param kuaiShouVideoGet
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-添加")
    @ApiOperation(value = "快手-获取视频接口-添加", notes = "快手-获取视频接口-添加")
    @PostMapping(value = "/add")
    public Result<KuaiShouVideoGet> add(@RequestBody KuaiShouVideoGet kuaiShouVideoGet) {
        Result<KuaiShouVideoGet> result = new Result<KuaiShouVideoGet>();
        try {
            kuaiShouVideoGetService.save(kuaiShouVideoGet);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaiShouVideoGet
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-编辑")
    @ApiOperation(value = "快手-获取视频接口-编辑", notes = "快手-获取视频接口-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaiShouVideoGet> edit(@RequestBody KuaiShouVideoGet kuaiShouVideoGet) {
        Result<KuaiShouVideoGet> result = new Result<KuaiShouVideoGet>();
        KuaiShouVideoGet kuaiShouVideoGetEntity = kuaiShouVideoGetService.getById(kuaiShouVideoGet.getId());
        if (kuaiShouVideoGetEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaiShouVideoGetService.updateById(kuaiShouVideoGet);
            //TODO 返回false说明什么？
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-通过id删除")
    @ApiOperation(value = "快手-获取视频接口-通过id删除", notes = "快手-获取视频接口-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            kuaiShouVideoGetService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-批量删除")
    @ApiOperation(value = "快手-获取视频接口-批量删除", notes = "快手-获取视频接口-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaiShouVideoGet> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<KuaiShouVideoGet> result = new Result<KuaiShouVideoGet>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaiShouVideoGetService.removeByIds(Arrays.asList(ids.split(StringUtils.COMMA)));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "快手-获取视频接口-通过id查询")
    @ApiOperation(value = "快手-获取视频接口-通过id查询", notes = "快手-获取视频接口-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaiShouVideoGet> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaiShouVideoGet> result = new Result<KuaiShouVideoGet>();
        KuaiShouVideoGet kuaiShouVideoGet = kuaiShouVideoGetService.getById(id);
        if (kuaiShouVideoGet == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaiShouVideoGet);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaiShouVideoGet> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaiShouVideoGet kuaiShouVideoGet = JSON.parseObject(deString, KuaiShouVideoGet.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouVideoGet, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaiShouVideoGet> pageList = kuaiShouVideoGetService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "快手-获取视频接口列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaiShouVideoGet.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("快手-获取视频接口列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaiShouVideoGet> listKuaiShouVideoGets = ExcelImportUtil.importExcel(file.getInputStream(), KuaiShouVideoGet.class, params);
                kuaiShouVideoGetService.saveBatch(listKuaiShouVideoGets);
                return Result.ok("文件导入成功！数据行数:" + listKuaiShouVideoGets.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
